	
	ORG 0000H
	LJMP MAIN
	
	ORG 0023H
	LJMP W_BUFER_C
	
	ORG 0030H
;;;;;;;;;;;;;;;;;
MAIN:
;;;;;;;;;;;;;;;;;
	MOV R0,#20H       ;ADRESA E WRITE POINTERIT NE BUFER_C
	MOV R1,#20H	  ;ADRESA E READ PINTERIT NE BUFER_C
	MOV R4,#00H      ;NUMERUESI I KARAKTEREVE NE BUFER_C
	LCALL SERIAL_INIT
LOOP:	
	LJMP LOOP
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	

;;;;;;;;;;;;;;;;
SERIAL_INIT:
;;;;;;;;;;;;;;;;
	MOV A,PCON
	SETB ACC.7
	MOV PCON,A    ;SMOD=1
	MOV SCON,#52H ;ENABLE TI, MODE 1
        MOV TMOD,#20H ;TIMER 1, MODE 2, 8-BIT AUTO RELOAD MODE
        MOV TH1,#-35  ;1200 BPS AUTO RELOAD VALUE
        SETB EA       ;GLOBAL INTERRUPT ENABLE
        SETB ES       ;SERIAL INTERRUPT ENABLE
        SETB PS       ;HIGH PRIORITY FOR SERIAL INTERRUPTS
        SETB TR1      ;START TIMER
        RET
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;
W_BUFER_C:
;;;;;;;;;;;;;;;;
	JNB RI,DALJA
	CLR RI
	MOV A,SBUF
	MOV @R0,A
	
	ADD A,#00110000B
	CJNE A,#'=',RRITE
	LCALL R_BUFER_C
	MOV R0,#20H
	MOV R4,#00H
	LJMP DALJA
	
RRITE:	INC R0
	INC R4
	
DALJA:	RETI
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
;;;;;;;;;;;;;;;;
R_BUFER_C:
;;;;;;;;;;;;;;;;
	CJNE R4,#00H,VAZHDO1
	LJMP EXIT
VAZHDO1:MOV A,R4
	ADD A,#00110000B
	MOV B,A
	
	MOV DPTR,#LISTA1
	MOV A,#00H
	MOVC A,@A+DPTR
	CJNE A,B,TJETER1
	MOV R1,#20H
	MOV R7,#01H
	LCALL KONTROLLO_FJALEN
	JB P0.0,TJETER1
	SETB P0.0
	LJMP EXIT
	
TJETER1:MOV A,R4
	ADD A,#00110000B
	MOV B,A
	
	MOV DPTR,#LISTA2
	MOV A,#00H
	MOVC A,@A+DPTR
	CJNE A,B,TJETER2
	MOV R1,#20H
	MOV R7,#01H
	LCALL KONTROLLO_FJALEN
	JB P0.0,TJETER2
	SETB P0.0
	LJMP EXIT
	
TJETER2:MOV A,R4
	ADD A,#00110000B
	MOV B,A
	
	MOV DPTR,#LISTA3
	MOV A,#00H
	MOVC A,@A+DPTR
	CJNE A,B,TJETER3
	MOV R1,#20H
	MOV R7,#01H
	LCALL KONTROLLO_FJALEN
	JB P0.0,TJETER3
	SETB P0.0
	LJMP EXIT
	
TJETER3:MOV A,R4
	ADD A,#00110000B
	MOV B,A
	
	MOV DPTR,#LISTA4
	MOV A,#00H
	MOVC A,@A+DPTR
	CJNE A,B,NUK_ESHTE
	MOV R1,#20H
	MOV R7,#01H
	LCALL KONTROLLO_FJALEN
	JB P0.0,NUK_ESHTE
	SETB P0.0
	LJMP EXIT

NUK_ESHTE:
	MOV DPTR,#MESAZHI2
	LCALL MESAZHI
EXIT:	RET
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;
KONTROLLO_FJALEN:
;;;;;;;;;;;;;;;;;;

PERSERI:MOV B,@R1
	MOV A,R7
	MOVC A,@A+DPTR
	
	CJNE A,#00H,KRAHASO
	MOV DPTR,#MESAZHI1
	LCALL MESAZHI	
	CLR P0.0
	LJMP KTHEHU
	
KRAHASO:CJNE A,B,KTHEHU
	INC R7
	INC R1
	LJMP PERSERI
		
KTHEHU:	RET
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;TRANSMETIMI I NJE KARAKTERI NE BAFER (PORTIN SERIK)	
;;;;;;;;;;;;;;;;
OUTCHAR:	
;;;;;;;;;;;;;;;;
	JNB TI,$
	CLR TI         
	MOV SBUF,A
	RET
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;
MESAZHI:
;;;;;;;;;
	MOV A,#0AH
	LCALL OUTCHAR
	MOV A,#0DH
	LCALL OUTCHAR
	MOV R3,#00H
RPT:	CJNE A,#00H,VAZHDO3
	MOV A,#0AH
	LCALL OUTCHAR
	MOV A,#0DH
	LCALL OUTCHAR
	RET
VAZHDO3:MOV A,R3
	MOVC A,@A+DPTR
	LCALL OUTCHAR
	INC R3
	LJMP RPT
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

MESAZHI1: DB ' KERKIMI U KRYE ME SUKSES, ESHTE GJETUR FJALA NE LISTE ',00H
MESAZHI2: DB ' NUK EGZISTON KJO FJALE NE LISTE ',00H

LISTA1: DB '6BESNIK',00H
LISTA2: DB '6DRITON',00H
LISTA3: DB '5FATON',00H
LISTA4: DB '5HYSEN',00H

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	


	END
